#!/usr/bin/env bash

# convert_audio.sh
# NikePlus
#
# Created by George King on 3/1/10.
# Copyright 2010 R/GA. All rights reserved.

# this script must be called from the project root directory (e.g. trunk).

# WARNING: running this script will replace ALL the audio files.
# this means that your svn diff will be massive; please don't waste space.

# TODO: figure out desired compression options
# see afconvert -h


function fail { echo "fail: $*"; exit 1; }

in_dir="$1"
out_dir="$2"

[[ -d $in_dir ]]    || fail "bad in_dir:" $in_dir
[[ -d $out_dir ]]   || fail "bad out_dir:" $out_dir


for i in `ls $in_dir`; do
    
    file_in=$in_dir/$i
    file_out=$out_dir/${i%%\.wav}.m4a
    
    [[ -r $file_in ]] || fail "missing file:" $file_in
    
    # setting --bitrate 96000 fails
    cmd="afconvert -f m4af $file_in $file_out"
    
    echo $cmd
    $cmd

    #exit 0
done
