#!/usr/bin/env python

# gen_attaboys_plist.py
# NikePlus
#
# Created by George King on 3/12/10.
# Copyright 2010 R/GA. All rights reserved.

# this script must be called from the project root directory (e.g. trunk).


from __future__ import print_function

import os
import os.path
import plistlib
import collections


root_dir = "np_resources/audio/attaboys"

dict = collections.defaultdict(list)


talents = os.listdir(root_dir)

for t in talents:
    if t.startswith("."): continue

    talent_dir = os.path.join(root_dir, t)
    files = [os.path.splitext(f)[0] for f in os.listdir(talent_dir) if not f.startswith(".")]
    print(t, files)
    for f in files:
        dict[f].append(t)

print("\ngenerated plist:")

for k in dict:
    print(k, "\n", dict[k])

plistlib.writePlist(dict, "np_resources/AttaboyTalents.plist")

