#!/usr/bin/env python

# gen_encouragements_plist.py
# NikePlus
#
# Modified by Robert Carlsen on 6/18/2010 from gen_attaboys_plist
# Created by George King on 3/12/10.
# Copyright 2010 R/GA. All rights reserved.

# this script must be called from the project root directory (e.g. trunk).


from __future__ import print_function

import sys
import os
import os.path
import plistlib
import collections

if (len(sys.argv) < 2):
    print("please provide the language code (eg. en_US)")
    sys.exit(0)

lang = sys.argv[1]
print("lang: " + lang)

root_dir = "np_resources/"+lang+"/audio/encouragements"

dict = collections.defaultdict(list)


encouragements = os.listdir(root_dir)

for t in encouragements:
    if t.startswith("."): continue

    thisfile = os.path.splitext(t)[0]
    print(thisfile)
    dict[0].append(thisfile)

print("\ngenerated plist:")

for k in dict:
    print(dict[k], "\n")

plistlib.writePlist(dict[0], "np_resources/"+lang+"/Encouragements.plist")

