#!/usr/bin/env bash

# create the NPRevision.plist file in the resources dir with the value of svnversion.

# this should be invoked from an Xcode target 'run script' build phase with the following settings:

# script: $PROJECT_DIR/scripts/gen_rev_header.sh
# input files: none
# output files: none

# note that the update of the plist happens after xcode calculates dependencies,
# so unless the file copied to the bundle will lag one build behind.
# touch this in the build script before running xcodebuild build to ensure that it is in sync.

# note that you can use svn to dynamically add the revision value to source,
# but it only updates files when they change.
# therefore, this isn't useful for a global revision number,
# because no single file can be expected to change on every commit.
# nonetheless, here is the propset example:

# trunk $ svn propset svn:keywords Rev np_source/Shared/NPVersion.h


rev=`svnversion`

path="$PROJECT_DIR/np_resources/NPRevision.plist"

echo "<?xml version=\"1.0\" encoding=\"UTF-8\"?>
<!DOCTYPE plist PUBLIC \"-//Apple//DTD PLIST 1.0//EN\" \"http://www.apple.com/DTDs/PropertyList-1.0.dtd\">
<plist version=\"1.0\">
<dict>
    <key>CurrentRevision</key>
    <string>r$rev</string>
</dict>
</plist>" > $path


echo "Revision number updated:" $rev
