import re
import codecs
import sys
import os

def findKey(arr, key):
    for i in range(len(arr)):
        if (arr[i]['key'] == key):
            return i
    return -1


def mergeStrings(fileA, fileB, fileC):
    
    oldString = ""
    newString = ""

    oldFile = open(fileA)
    
    try:
        oldString = unicode(oldFile.read(), "utf-16")
    except:
        oldString = unicode(oldFile.read(), "utf-8")
    
    #deal with random encodings from incoming translations
    try:
        newFile = open(fileB)
        newString = unicode(newFile.read(), "utf-8")
    except:
        newFile = open(fileB)
        newString = unicode(newFile.read(), "utf-16")

    #regex = re.compile("(\*.*?\*).*?(\".*?\").*?(\".*?\")", re.DOTALL | re.IGNORECASE)
    regex = re.compile("(\*.*?\*).*?(\".*?)\s=.*?(\".*?)\s*;\s*\n", re.DOTALL | re.IGNORECASE)
    
    oldMatches = [m.groups() for m in regex.finditer(oldString)]
    newMatches = [m.groups() for m in regex.finditer(newString)]
    
    debugLog('Found %d strings in baseFile' % (len(oldMatches)))
    debugLog('Found %d strings in patchFile' % (len(newMatches)))
    
    newDict = {}
    oldOrderedDict = []
    
    for m in oldMatches:
        oldOrderedDict.append({'value' : m[2], 'comment' : m[0], 'key' : m[1]})
    
    for m in newMatches:
        newDict[m[1]] = {'value' : m[2], 'comment' : m[0]}
    
    oldFile.close()
    newFile.close()
    
    newStringCount = 0
    patchedStringCount = 0
    
    #do the merge
    for newKey in newDict.keys():
        index = findKey(oldOrderedDict, newKey)
        if (index >= 0):
            if (oldOrderedDict[index]['value'] != newDict[newKey]['value'] or oldOrderedDict[index]['comment'] != newDict[newKey]['comment']):
                oldOrderedDict[index] = {'value' : newDict[newKey]['value'], 'comment' : newDict[newKey]['comment'], 'key' : newKey}
                patchedStringCount += 1
        else:
            oldOrderedDict.append({'value' : newDict[newKey]['value'], 'comment' : newDict[newKey]['comment'], 'key' : newKey})
            newStringCount += 1
    out = ""
    
    debugLog('%d strings were changed' % (patchedStringCount))
    debugLog('%d new strings were added' % (newStringCount))
    
    #build output
    for S in oldOrderedDict:
        out = out + '/%s/\n%s = %s;\n\n' % (S['comment'], S['key'], S['value'])

    #write it
    mergedFile = open(fileC, 'w')
    mergedFile.write(out.encode('utf-16'))
    mergedFile.close()
    debugLog('Done!')

def debugLog(s):
    print ('**mergeStrings: %s' % (s))

def main():
    if (len(sys.argv) >= 3):
        baseFile = sys.argv[1]
        patchFile = sys.argv[2]
        if (len(sys.argv) == 4):
            destinationFile = sys.argv[3]
        else:
            destinationFile = baseFile
        
        debugLog('Merging strings from %s and %s into %s' % (baseFile, patchFile, destinationFile))
        if (not os.path.exists(baseFile)):
            debugLog('%s does not exist!' % baseFile)
            return
        if (not os.path.exists(patchFile)):
            debugLog('%s does not exist!' % patchFile)
            return
        if (not os.path.exists(destinationFile)):
            debugLog('%s does not exist!' % destinationFile)
            return
        mergeStrings(baseFile, patchFile, destinationFile)
    else:
        debugLog("Usage: mergeStrings baseFile patchFile [destinationFile]")
        debugLog("destinationFile optional, default is baseFile")

if __name__ == "__main__":
    main()

