#!/usr/bin/env python

# quick and dirty profiling script
# insert LOG_METHOD and LOG_SECTION() statements into objective-c code to print logs that can be pasted into prof.txt


from __future__ import print_function

import re
import math
import datetime


def parseTimestamp(string):
    r = re.compile(r"^(\d{4})-(\d{2})-(\d{2}) (\d{2}):(\d{2}):(\d{2}.\d{3})")
    m = r.match(string)
    if not m: return None
    
    components = [float(g) for g in m.groups()]
    components.append(math.fmod(components[5], 1) * 1000000) # get microseconds
    
    return datetime.datetime(*[int(c) for c in components])


f = open("prof.txt")

startTime = None

for line in f:
    l = line.strip()
   
    d = parseTimestamp(l)
    if d:
        # parse out text from LOG_METHOD or LOG_SECTION()
        r = re.compile(r" -\[(\w+) (\w(?:\w|:)*)\](?: '(.*)')?$")
        m = r.search(l)
        
        if (m):
            g = m.groups()

            if startTime and g[2] != None:
                delta = d - startTime
                print(delta, *g)
            
            startTime = d;
    else:
        print(l)
